﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections.ObjectModel;

using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

public partial class _Default : System.Web.UI.Page
{
    private string callbackResult;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            callbackResult = string.Empty;

            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/App_Data/Countries02.shp"));
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay staticOverlay = new LayerOverlay("WorldStaticOverlay");
            staticOverlay.IsBaseOverlay = false;
            staticOverlay.Layers.Add("WorldLayer", worldLayer);

            Map1.CustomOverlays.Add(staticOverlay);
            Map1.CurrentExtent = new RectangleShape(-125, 72, 50, -46);
        }
    }

    public string GetCallbackResult()
    {
        return callbackResult;
    }

    public void RaiseCallbackEvent(string eventArgument)
    {
        string countryName = eventArgument.Trim();
        LayerOverlay overlay = Map1.CustomOverlays[0] as LayerOverlay;

        if (overlay != null)
        {
            ShapeFileFeatureLayer layer = overlay.Layers[0] as ShapeFileFeatureLayer;
            if (layer != null)
            {
                if (!layer.IsOpen)
                {
                    layer.Open();
                }
                Collection<Feature> returnFeatures = layer.QueryTools.GetFeaturesByColumnValue("CNTRY_NAME", countryName);
                if (returnFeatures.Count > 0)
                {
                    callbackResult = returnFeatures[0].GetBoundingBox().ToString();
                }
            }
        }
    }
}
